
#include "string.h"
#include "Modbus.h"

#include "SEGGER_RTT.h"
#include "SEGGER_RTT_Conf.h"

#include "Modbus_Monitor.h"
#include "nrf_drv_timer.h"

MODBUS_PARAMETER ModbusParameter;
extern uint8_t       ModbusWriteFlag;
extern const nrf_drv_timer_t m_timer;

static int auchCRCLo[] = 
{
    0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 
    0x07, 0xC7, 0x05, 0xC5, 0xC4, 0x04, 0xCC, 0x0C, 0x0D, 0xCD, 
    0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09, 
    0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A, 
    0x1E, 0xDE, 0xDF, 0x1F, 0xDD, 0x1D, 0x1C, 0xDC, 0x14, 0xD4, 
    0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3, 
    0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 
    0xF2, 0x32, 0x36, 0xF6, 0xF7, 0x37, 0xF5, 0x35, 0x34, 0xF4, 
    0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A, 
    0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29, 
    0xEB, 0x2B, 0x2A, 0xEA, 0xEE, 0x2E, 0x2F, 0xEF, 0x2D, 0xED, 
    0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26, 
    0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 
    0x61, 0xA1, 0x63, 0xA3, 0xA2, 0x62, 0x66, 0xA6, 0xA7, 0x67, 
    0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F, 
    0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68, 
    0x78, 0xB8, 0xB9, 0x79, 0xBB, 0x7B, 0x7A, 0xBA, 0xBE, 0x7E, 
    0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5, 
    0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 
    0x70, 0xB0, 0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92, 
    0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C, 
    0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B, 
    0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89, 0x4B, 0x8B, 
    0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C, 
    0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 
    0x43, 0x83, 0x41, 0x81, 0x80, 0x40  
} ;
/****************************************************************************************/
/*???CRC*/
static int auchCRCHi[] = 
{
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 
    0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 
    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 
    0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 
    0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 
    0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 
    0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 
    0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 
    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 
    0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 
    0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 
    0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 
    0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 
    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 
    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40 
} ;


static unsigned short Modbus_CRC16(unsigned char *Buff_addr,unsigned int len)
{                                                                        
    unsigned char uchCRCHi = 0xFF;           
    unsigned char uchCRCLo = 0xFF;           
    unsigned int uIndex=0;           
    unsigned int temp;
    unsigned int asss;
    asss=len;                        						
    while (asss>0)	                 						
    {
        uIndex = uchCRCHi ^ *Buff_addr++;         
        uchCRCHi = uchCRCLo ^ auchCRCHi[uIndex];
        uchCRCLo = auchCRCLo[uIndex];
        
        asss-=1;
    }
    temp=uchCRCHi;
    return(temp <<8 | uchCRCLo);
}


__weak unsigned char IsSlaveAddr_OK(unsigned char TempAddr)
{
		return 0;
}

__weak unsigned char IsSuperSlaveAddr_OK(unsigned char TempAddr)
{
		return 0;
}

unsigned char Is_CRC_Check_OK(void)
{
		unsigned short Temp_CRC16;
		Temp_CRC16=ModbusParameter.ReceiveBuffer[ModbusParameter.ReceiveLength-2]*256+
							 ModbusParameter.ReceiveBuffer[ModbusParameter.ReceiveLength-1];
	
		if(ModbusParameter.ReceiveLength >= 2)
		{//长度要大于等于2，否则hardfault
				if(Temp_CRC16==Modbus_CRC16(ModbusParameter.ReceiveBuffer,ModbusParameter.ReceiveLength-2))
				{
						return 0;
				}
		}
		return 1;
}

void ModbusInit(void)
{
		ModbusParameter.ReceiveLength = 0;
}


__weak MODBUS_EXCEPTION_CODE_ENUM GetHoldingRegisterData(unsigned char* TempPtr,unsigned short TempAddr,unsigned char TempLength)
{
		return EXCEPTION_CODE_NULL;
}

MODBUS_EXCEPTION_CODE_ENUM ModbusReadHoldRegisters(void)
{
		unsigned short TempDataAddr;
		unsigned short TempLength;
    
    TempDataAddr = ModbusParameter.ReceiveBuffer[2]*256+ModbusParameter.ReceiveBuffer[3];//数据起始地址
		TempLength = ModbusParameter.ReceiveBuffer[5];
		
		if(TempLength>64)//读取数据一次不能超过32个word
				return EXCEPTION_CODE_3;

		ModbusParameter.TransmitBuffer[0]=ModbusParameter.ReceiveBuffer[0];
		ModbusParameter.TransmitBuffer[1]=ModbusParameter.ReceiveBuffer[1];
		ModbusParameter.TransmitLength = 2;

		MODBUS_EXCEPTION_CODE_ENUM TempException;
		TempException = GetHoldingRegisterData(&ModbusParameter.TransmitBuffer[3],TempDataAddr,TempLength);
		if(TempException == EXCEPTION_CODE_NULL)
		{
				ModbusParameter.TransmitBuffer[2]=ModbusParameter.ReceiveBuffer[5]*2;
				ModbusParameter.TransmitLength+=TempLength*2+1;
		}
		else
		{
				ModbusParameter.TransmitBuffer[1]|=0x80;
				ModbusParameter.TransmitBuffer[2]=TempException;
				ModbusParameter.TransmitLength+=1;
		}
		unsigned short TempData_CRC;
		TempData_CRC = Modbus_CRC16(ModbusParameter.TransmitBuffer,ModbusParameter.TransmitLength);
		
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)(TempData_CRC>>8);
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)TempData_CRC;
		
				
		return TempException;
}


__weak MODBUS_EXCEPTION_CODE_ENUM WriteOneHoldingRegister(unsigned short TempDataAddr,unsigned short TempData)
{
		return EXCEPTION_CODE_NULL;
}

MODBUS_EXCEPTION_CODE_ENUM ModbusWriteHoldRegisters(void)
{
		unsigned short TempDataAddr;
		unsigned short TempData;
//		nrf_drv_timer_disable(&m_timer);
    TempDataAddr = ModbusParameter.ReceiveBuffer[2]*256+ModbusParameter.ReceiveBuffer[3];//数据起始地址
		TempData = ModbusParameter.ReceiveBuffer[4]*256+ModbusParameter.ReceiveBuffer[5];
	
//		for(uint16_t i=0;i<ModbusParameter.ReceiveLength;i++)
//		{
//			SEGGER_RTT_printf(0,"Recievedata:%d\n",ModbusParameter.ReceiveBuffer[i]);
//		}
	
		ModbusParameter.TransmitBuffer[0]=ModbusParameter.ReceiveBuffer[0];
		ModbusParameter.TransmitBuffer[1]=ModbusParameter.ReceiveBuffer[1];
		ModbusParameter.TransmitLength = 2;
	
		MODBUS_EXCEPTION_CODE_ENUM TempException;
		TempException = WriteOneHoldingRegister(TempDataAddr,TempData);
		if(TempException == EXCEPTION_CODE_NULL)
		{
				ModbusParameter.TransmitBuffer[2]=ModbusParameter.ReceiveBuffer[2];
				ModbusParameter.TransmitBuffer[3]=ModbusParameter.ReceiveBuffer[3];
				ModbusParameter.TransmitBuffer[4]=ModbusParameter.ReceiveBuffer[4];
				ModbusParameter.TransmitBuffer[5]=ModbusParameter.ReceiveBuffer[5];
				ModbusParameter.TransmitLength+=4;
		}
		else
		{
				ModbusParameter.TransmitBuffer[1]|=0x80;
				ModbusParameter.TransmitBuffer[2]=TempException;
				ModbusParameter.TransmitLength+=1;
		}
		unsigned short TempData_CRC;
		TempData_CRC = Modbus_CRC16(ModbusParameter.TransmitBuffer,ModbusParameter.TransmitLength);
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)(TempData_CRC>>8);
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)TempData_CRC;
				
		return TempException;
		
}
__weak MODBUS_EXCEPTION_CODE_ENUM WriteOneOfMultipleHoldingRegister(unsigned short TempDataAddr,unsigned short TempData)
{
		return EXCEPTION_CODE_NULL;
}
__weak MODBUS_EXCEPTION_CODE_ENUM WriteMultipleHoldingRegister(unsigned short TempDataAddr)
{
		return EXCEPTION_CODE_NULL;
}


MODBUS_EXCEPTION_CODE_ENUM ModbusWriteMutipleRegisters(void)
{
		unsigned short TempDataAddr;
		unsigned short TempLength;
    
    TempDataAddr = ModbusParameter.ReceiveBuffer[2]*256+ModbusParameter.ReceiveBuffer[3];//数据起始地址
		TempLength = ModbusParameter.ReceiveBuffer[4]*256+ModbusParameter.ReceiveBuffer[5];
	
		unsigned short i;
		unsigned short TempAddr;
		unsigned short TempData;
		MODBUS_EXCEPTION_CODE_ENUM TempException;
	
		TempAddr = TempDataAddr;

		for(i=0;i<TempLength;i++)
		{
				TempData = ModbusParameter.ReceiveBuffer[7+2*i]*256+ModbusParameter.ReceiveBuffer[7+2*i+1];
				TempException = WriteOneOfMultipleHoldingRegister(TempAddr,TempData);
				SEGGER_RTT_printf(0,"Addr %d Data %d\n",TempAddr,TempData);

				if(TempException != EXCEPTION_CODE_NULL)
				{	
						SEGGER_RTT_printf(0, "library multiple break\n",0);
						break;
				}
				TempAddr++;
		}
		
		ModbusParameter.TransmitBuffer[0]=ModbusParameter.ReceiveBuffer[0];
		ModbusParameter.TransmitBuffer[1]=ModbusParameter.ReceiveBuffer[1];
		ModbusParameter.TransmitLength = 2;
		
		if(TempException == EXCEPTION_CODE_NULL)
		{
				WriteMultipleHoldingRegister(TempDataAddr);
				ModbusParameter.TransmitBuffer[2]=ModbusParameter.ReceiveBuffer[2];
				ModbusParameter.TransmitBuffer[3]=ModbusParameter.ReceiveBuffer[3];
				ModbusParameter.TransmitBuffer[4]=ModbusParameter.ReceiveBuffer[4];
				ModbusParameter.TransmitBuffer[5]=ModbusParameter.ReceiveBuffer[5];
				ModbusParameter.TransmitLength+=4;
		}
		else
		{
				ModbusParameter.TransmitBuffer[1]|=0x80;
				ModbusParameter.TransmitBuffer[2]=TempException;
				ModbusParameter.TransmitLength+=1;
		}
		ModbusWriteFlag=1;
		unsigned short TempData_CRC;
		TempData_CRC = Modbus_CRC16(ModbusParameter.TransmitBuffer,ModbusParameter.TransmitLength);
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)(TempData_CRC>>8);
		ModbusParameter.TransmitBuffer[ModbusParameter.TransmitLength++]=(unsigned char)TempData_CRC;
		
		return TempException;
}

const MODBUS_CODE_FUNCTION_TPDF ModbusCodeFunction[] = 
{
		{0x03,ModbusReadHoldRegisters},
		{0x06,ModbusWriteHoldRegisters},
		{0x10,ModbusWriteMutipleRegisters}
};

void ModbusGetReceiveFrame(unsigned char* TempPtr,unsigned char TempLength)
{
		unsigned char i;
		for(i=0;i<TempLength;i++)
		{
				ModbusParameter.ReceiveBuffer[i]=*(TempPtr+i);
		}
		ModbusParameter.ReceiveLength = TempLength;
}

__weak void ResponseModbus(void)
{
		
}

extern MODBUS_SET	ModbusSet;

void MODBUS_Process(unsigned char* TempPtr,unsigned char Length)
{
		ModbusParameter.ReceiveLength = Length;
		memcpy(ModbusParameter.ReceiveBuffer,TempPtr,ModbusParameter.ReceiveLength);
		if(ModbusParameter.ReceiveLength)
		{
//				SEGGER_RTT_printf(0, "ModbusParameter.ReceiveLength is %d \n",ModbusParameter.ReceiveLength);
//				SEGGER_RTT_printf(0, "receive char is :\n",0);
//				unsigned char i = 0;
//				for(i=0;i<ModbusParameter.ReceiveLength;i++)
//				{
//						SEGGER_RTT_printf(0, "%X \n",ModbusParameter.ReceiveBuffer[i]);
//				}
				
				if((IsSlaveAddr_OK(ModbusParameter.ReceiveBuffer[0])==0) || (IsSuperSlaveAddr_OK(ModbusParameter.ReceiveBuffer[0])==0) )//******************8**超级地址加在这里面 或条件***********************
				{
						if(Is_CRC_Check_OK() == 0)
						{
							
								ModbusParameter.ReceiveBuffer[0] = ModbusSet.SlaveAddr;
								unsigned char i;
								unsigned char TempLength;
								MODBUS_CODE_FUNCTION_TPDF* TempPtr;
								
							
							
//								SEGGER_RTT_printf(0, "modbus crc ok\n",0);
								TempPtr = (MODBUS_CODE_FUNCTION_TPDF*)ModbusCodeFunction;
								TempLength = sizeof(ModbusCodeFunction)/sizeof(MODBUS_CODE_FUNCTION_TPDF);
								for(i=0;i<TempLength;i++)
								{
										if(TempPtr->FunctionCode == ModbusParameter.ReceiveBuffer[1])
										{
//												SEGGER_RTT_printf(0, "modbus function code asset\n",0);
												TempPtr->FunctionPtr();
												break;
										}
										TempPtr++;
								}
								if(ModbusParameter.TransmitLength)
								{
										ResponseModbus();
								}
//								SEGGER_RTT_printf(0, "Modbus is processed\n\n",0);	
						}
						else
						{
								SEGGER_RTT_printf(0, "modbus crc error\n",0);	
						}	
						
				}  //********************************超级地址加在这里************************************
				else 
				{
						SEGGER_RTT_printf(0, "modbus addr error\n",0);	
				}
				ModbusInit();
		}
}



